﻿{* $Id: smbc_cctkn.tpl by tommy from cs-cart.jp 2013 *}
{* 2017/09 : トークン決済（シングルユース方式）に対応 *}

{script src="js/lib/maskedinput/jquery.maskedinput.min.js"}
{script src="js/lib/creditcardvalidator/jquery.creditCardValidator.js"}

<div class="clearfix">

    <input type="hidden" id="smbc_token_errormsg" value="">
    <input type="hidden" id="smbc_token_error_detail" name="payment_info[token_error_detail]">
    <input type="hidden" name="payment_info[token_single]" id="smbc_token_value" />

    <div class="credit-card">
        <div class="control-group">
            <label for="cc_number{$id_suffix}" class="control-label cm-required">{__("card_number")}</label>
            <div class="controls">
                <input id="cc_number{$id_suffix}" size="35" type="text" value="" class="input-big cm-autocomplete-off" />
            </div>
            <ul class="cc-icons-wrap cc-icons unstyled" id="cc_icons{$id_suffix}">
                <li class="cc-icon cm-cc-default"><span class="default">&nbsp;</span></li>
                <li class="cc-icon cm-cc-visa"><span class="visa">&nbsp;</span></li>
                <li class="cc-icon cm-cc-visa_electron"><span class="visa-electron">&nbsp;</span></li>
                <li class="cc-icon cm-cc-mastercard"><span class="mastercard">&nbsp;</span></li>
                <li class="cc-icon cm-cc-maestro"><span class="maestro">&nbsp;</span></li>
                <li class="cc-icon cm-cc-amex"><span class="american-express">&nbsp;</span></li>
                <li class="cc-icon cm-cc-discover"><span class="discover">&nbsp;</span></li>
            </ul>
        </div>

        <div class="control-group">
            <label for="cc_exp_month{$id_suffix}" class="control-label cm-required">{__("valid_thru")}</label>
            <div class="controls clear">
                <div class="cm-field-container nowrap">
                    <input type="text" id="cc_exp_month{$id_suffix}" value="" size="2" maxlength="2" class="input-small" />&nbsp;/&nbsp;<input type="text" id="cc_exp_year{$id_suffix}" value="" size="2" maxlength="2" class="input-small" />
                </div>
            </div>
        </div>

        <div class="control-group cvv-field">
            <label for="cc_cvv2{$id_suffix}" class="control-label cm-required cm-integer cm-autocomplete-off">{__("jp_smbc_security_code")}</label>
            <div class="controls">
                <input id="cc_cvv2{$id_suffix}" type="text" value="" size="4" maxlength="4"/>
                <div class="cvv2">{__("jp_smbc_what_is_security_code")}
                    <div class="popover fade bottom in">
                        <div class="arrow"></div>
                        <h3 class="popover-title">{__("jp_smbc_what_is_security_code")}</h3>
                        <div class="popover-content">
                            <div class="cvv2-note">
                                <div class="card-info clearfix">
                                    <div class="cards-images">
                                        <img src="{$images_dir}/visa_cvv.png" border="0" alt="" />
                                    </div>
                                    <div class="cards-description">
                                        <strong>{__("visa_card_discover")}</strong>
                                        <p>{__("credit_card_info")}</p>
                                    </div>
                                </div>
                                <div class="card-info ax clearfix">
                                    <div class="cards-images">
                                        <img src="{$images_dir}/express_cvv.png" border="0" alt="" />
                                    </div>
                                    <div class="cards-description">
                                        <strong>{__("american_express")}</strong>
                                        <p>{__("american_express_info")}</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="control-group">
            <label for="jp_cc_method" class="control-label cm-required">{__("jp_cc_method")}</label>
            <div class="controls">
                <select id="jp_cc_method" name="payment_info[jp_cc_method]" onchange="fn_check_smbc_cc_payment_type(this.value);">

                    {if $payment_method.processor_params.shiharai_kbn.1 == 'true'}
                        <option value="1">{__("jp_cc_onetime")}</option>
                    {/if}
                    {if $payment_method.processor_params.shiharai_kbn.61 == 'true'}
                        <option value="61">{__("jp_cc_installment")}</option>
                    {/if}
                    {if $payment_method.processor_params.shiharai_kbn.91 == 'true'}
                        <option value="91">{__("jp_cc_bonus_onetime")}</option>
                    {/if}
                    {if $payment_method.processor_params.shiharai_kbn.80 == 'true'}
                        <option value="80">{__("jp_cc_revo")}</option>
                    {/if}
                </select>
            </div>
        </div>

        {if $payment_method.processor_params.shiharai_kbn.61 == 'true'}
        <div class="control-group hidden" id="display_smbc_cc_splict_count">
            <label for="jp_cc_installment_times" class="control-label cm-required">{__("jp_cc_installment_times")}</label>
            <div class="controls">
                <select id="jp_cc_installment_times" name="payment_info[jp_cc_installment_times]">
                    {foreach from=$payment_method.processor_params.paycount item=paycount key=paycount_key name="paycounts"}
                        {if $payment_method.processor_params.paycount.$paycount_key == 'true'}
                            <option value="{$paycount_key}">{$paycount_key}{__("jp_paytimes_unit")}</option>
                        {/if}
                    {/foreach}
                </select>
            </div>
        </div>
        {/if}

        {if $payment_method.processor_params.register_card_info == 'true' && $auth.user_id && $auth.user_id > 0}
        <div class="control-group">
            <label for="register_card_info" class="control-label cm-required">{__("jp_smbc_cc_register_card_info_use")}</label>
            <div class="controls">
                <input type="radio" name="payment_info[register_card_info]" id="register_yes" value="true" checked="checked" class="radio" /> {__("yes")}
                &nbsp;&nbsp;
                <input type="radio" name="payment_info[register_card_info]" id="register_no" value="false" class="radio" /> {__("no")}
            </div>
        </div>
        {/if}

    </div>
</div>

<script type="text/javascript">
    (function(_, $) {
        $(document).ready(function() {
            var icons = $('#cc_icons{$id_suffix} li');

            $("#cc_number{$id_suffix}").mask("9999 9999 9999 9?999", {
                placeholder: ' '
            });

            $("#cc_cvv2{$id_suffix}").mask("999?9", {
                placeholder: ''
            });

            $("#cc_exp_month{$id_suffix},#cc_exp_year{$id_suffix}").mask("99", {
                placeholder: ''
            });

            $('#cc_number{$id_suffix}').validateCreditCard(function(result) {
                icons.removeClass('active');
                if (result.card_type) {
                    icons.filter('.cm-cc-' + result.card_type.name).addClass('active');

                    if (['visa_electron', 'maestro', 'laser'].indexOf(result.card_type.name) != -1) {
                        $('label[for=cc_cvv2{$id_suffix}]').removeClass('cm-required');
                    } else {
                        $('label[for=cc_cvv2{$id_suffix}]').addClass('cm-required');
                    }
                }
            });
            fn_check_smbc_cc_payment_type($('#smbc_cc_payment_type').val());
        });
    })(Tygh, Tygh.$);

    var checkoutForm = $('#jp_payments_form_id_{$tab_id}');
    checkoutForm.off('submit', submitHandler);
    checkoutForm.on('submit', submitHandler);

    // チェックアウトフォームのsubmitイベントハンドラ
    function submitHandler(event) {
        event.preventDefault();

        // フォームのValidationチェック
        var isFormVal = false;
        var objCCNum = document.getElementById('cc_number{$id_suffix}');
        var objExpYear = document.getElementById('cc_exp_year{$id_suffix}');
        var objExpMonth = document.getElementById('cc_exp_month{$id_suffix}');
        var objCVV2 = document.getElementById('cc_cvv2{$id_suffix}');

        objCCNum.value = objCCNum.value.replace(/\s+/g, "");

        if(objCCNum.value != "" && objExpYear.value != "" && objExpYear.value != "" && objExpMonth.value != "" && objCVV2.value != ""){
            isFormVal = true;
        }

        // フォームのValidationがOKの場合
        if(isFormVal) {
                Fstokenizer().setConfig(
                    {
                        shop_cd: '{$smbc_shop_cd}',
                        syuno_co_cd: '{$smbc_shuno_co_cd}',
                        token: {
                            api_key: '{$payment_method.processor_params.api_key}',
                            mode: 'S',
                            usecvv: true
                        },
                        elems: {
                            card: 'cc_number{$id_suffix}',
                            yy: 'cc_exp_year{$id_suffix}',
                            mm: 'cc_exp_month{$id_suffix}',
                            cvv: 'cc_cvv2{$id_suffix}',
                            token: 'smbc_token_value',
                            error: 'smbc_token_errormsg'
                        }
                    });

            var smbc_token = Fstokenizer().getToken();

            {literal}
            if (smbc_token == false) {
                var smbc_errmsg = $('#smbc_token_errormsg').text();
                if (smbc_errmsg) {
                    $("#smbc_token_error_detail").val(smbc_errmsg);
                }
                checkoutForm.get(0).submit();
            } else {
                checkoutForm.get(0).submit();
            }
            {/literal}
        }
    }

    function fn_check_smbc_cc_payment_type(payment_type)
    {
        if (payment_type == '61') {
            (function ($) {
                $(document).ready(function() {
                    $('#display_smbc_cc_splict_count').switchAvailability(false);
                });
            })(jQuery);
        } else {
            (function ($) {
                $(document).ready(function() {
                    $('#display_smbc_cc_splict_count').switchAvailability(true);
                });
            })(jQuery);
        }
    }
</script>
